    

#include <unistd.h>

#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "sigdef.h"
#include "screendef.h"
#include "seldef.h"
#include "thrdef.h"
#include "txdef.h"


void tx_input(void)
{
int ia, ib, pa, pb;
int nread;
//char s[80];
thread_status_flag[THREAD_TX_INPUT]=THRFLAG_ACTIVE;
if(tx.input_bytes == 2)
  {
  nread=read(tx_audio_in,&tx_micbuf_shi[mic_pa],tx_read_bytes); 
  }
else
  {
  nread=read(tx_audio_in,&tx_micbuf_int[mic_pa],tx_read_bytes); 
  }
if(nread != tx_read_bytes)
  {
  lirerr(1263);
  goto tx_input_x;
  }  
mic_pa=(mic_pa+tx_input_block)&tx_micbuf_mask;
while(!kill_all_flag && thread_command_flag[THREAD_TX_INPUT] == THRFLAG_ACTIVE)
  {
  if(tx.input_bytes == 2)
    {
    nread=read(tx_audio_in,&tx_micbuf_shi[mic_pa],tx_read_bytes); 
    }
  else
    {
    nread=read(tx_audio_in,&tx_micbuf_int[mic_pa],tx_read_bytes); 
    }
  if(nread != tx_read_bytes)
    {
    lirerr(1263);
    goto tx_input_x;
    }  
  mic_pa=(mic_pa+tx_input_block)&tx_micbuf_mask;
// Copy the input to tx_fft1 while multiplying with the window function.
  ib=2*tx_fftsize-1;
  pa=mic_px;
  pb=(pa+ib)&tx_rfbuf_mask;
  if(tx.input_bytes == 2)
    {
    if(tx.input_channels==1)
      {
      for( ia=0; ia<tx_fftsize; ia++)
        {
        tx_fft1[tx_fft_permute[ia]]=tx_micbuf_shi[pa]*tx_fft_win[ia];
        tx_fft1[tx_fft_permute[ib]]=tx_micbuf_shi[pb]*tx_fft_win[ia];
        ib--; 
        pa=(pa+1)&tx_rfbuf_mask;
        pb=(pb+tx_rfbuf_mask)&tx_rfbuf_mask;
        }
      }
    else
      {
      for( ia=0; ia<tx_fftsize; ia++)
        {
        tx_fft1[tx_fft_permute[ia]]=tx_micbuf_shi[2*pa]*tx_fft_win[ia];
        tx_fft1[tx_fft_permute[ib]]=tx_micbuf_shi[2*pb]*tx_fft_win[ia];
        ib--; 
        pa=(pa+1)&tx_rfbuf_mask;
        pb=(pb+tx_rfbuf_mask)&tx_rfbuf_mask;
        }
      }  
    }
  else
    {
    if(tx.input_channels==1)
      {
      for( ia=0; ia<tx_fftsize; ia++)
        {
        tx_fft1[tx_fft_permute[ia]]=tx_micbuf_int[pa]*tx_fft_win[ia];
        tx_fft1[tx_fft_permute[ib]]=tx_micbuf_int[pb]*tx_fft_win[ia];
        ib--; 
        pa=(pa+1)&tx_rfbuf_mask;
        pb=(pb+tx_rfbuf_mask)&tx_rfbuf_mask;
        }
      }
    else
      {
      for( ia=0; ia<tx_fftsize; ia++)
        {
        tx_fft1[tx_fft_permute[ia]]=tx_micbuf_int[2*pa]*tx_fft_win[ia];
        tx_fft1[tx_fft_permute[ib]]=tx_micbuf_int[2*pb]*tx_fft_win[ia];
        ib--; 
        pa=(pa+1)&tx_rfbuf_mask;
        pb=(pb+tx_rfbuf_mask)&tx_rfbuf_mask;
        }
      }  
    }
/*
  m=timf1_bytemask/sizeof(short int);
  k=m+1;
  p0=timf1p_px/sizeof(short int);
  p0=(p0-fft1_interleave_points*2+timf1_bytes)&m;
  pa=p0;

    pb=(pa+ib)&m;
    for( ia=0; ia<tx_fftsize; ia++)
      {
      fftw_tmp[fft1_permute[ia  ]]=timf1_short_int[pa]*fft1_window[ia];
      fftw_tmp[fft1_permute[ib  ]]=timf1_short_int[pb]*fft1_window[ia];
      ib--; 
      pa=(pa+1)&m;
      pb=(pb-1+k)&m;
      }

fft_real_to_hermitian( fftw_tmp, 2*fft1_size, fft1_n, fft1tab);
// Output is {Re(z^[0]),...,Re(z^[n/2),Im(z^[n/2-1]),...,Im(z^[1]).
  pc=fft1_pa;
  fft1_float[pc+1]=fftw_tmp[0];
  fft1_float[pc  ]=fftw_tmp[fft1_size];
  k=fft1_first_point;
  m=fft1_last_point;
  if(k==0)k=1;
  pc+=2*k;
  for(ia=k; ia <= m; ia++)
    {
    fft1_float[pc+1]=fftw_tmp[ia  ];
    fft1_float[pc  ]=fftw_tmp[2*fft1_size-ia];
    pc+=2;
    }


*/   
  lir_sem_post(SEM_TXINPUT);
  }
tx_input_x:;
thread_status_flag[THREAD_TX_INPUT]=THRFLAG_RETURNED;
lir_sem_post(SEM_TXINPUT);
while(thread_command_flag[THREAD_TX_INPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

void tx_output(void)
{
thread_status_flag[THREAD_TX_OUTPUT]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_TX_OUTPUT] == THRFLAG_ACTIVE)
  {
  }
thread_status_flag[THREAD_TX_OUTPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_TX_OUTPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}
