

// Structure for voicelab parameters
typedef struct {
float noise_level;
float wait_time;
float rx_filter_low;
float rx_filter_high;
float rx_filter_slope;
float pre_gain;
float pre_agc_time;
float mic_filter_low;
float mic_filter_high;
float mic_filter_slope;
float mic_gain;
float mic_agc_time;
float af_filter_low;
float af_filter_high;
float af_filter_slope;
float af_gain;
float af_agc_time;
float rf_filter1_low;
float rf_filter1_high;
float rf_filter1_slope;
float rf_gain1;
float rf_agc_time1;
float rf_filter2_low;
float rf_filter2_high;
float rf_filter2_slope;
float rf_gain2;
float rf_agc_time2;
float rf_filter3_low;
float rf_filter3_high;
float rf_filter3_slope;
float alc_gain;
float alc_time;
}VOICELAB_PARM;

extern int tx_micbuf_size;
extern int tx_micbuf_mask;
extern int tx_rfbuf_size;
extern int tx_rfbuf_mask;
extern int tx_output_size;
extern int tx_output_mask;
extern int txmem_size;
extern int tx_read_bytes;
extern int mic_pa;
extern int mic_px;
extern int tx_input_block;

extern short int *tx_micbuf_shi;
extern int *tx_micbuf_int;
extern float *tx_fft1;
extern float *tx_fft2;
extern float *tx_rf1;
extern float *tx_rf2;
extern int *tx_outbuf_int;
extern short int *tx_outbuf_shi;
extern COSIN_TABLE *tx_fft_table;
extern unsigned short int *tx_fft_permute;
extern float *tx_fft_win;
extern float *tx_tmp;

extern int tx_fftsize;
extern int tx_fftn;
extern int tx_mask;
extern int *txmem_handle;

extern int tx_audio_in;
extern int tx_audio_out;
extern int tx_flag;
extern int phonetics_flag[256];
extern float phonetics_ampl[256];
extern int phonetics_line[256];
extern int phonetics_col[256];
extern int phonetics_pointer[256];
extern float *phonetics;
extern int phonetics_length;
extern int fixed_phonetics_flag;
extern int vl_size;
extern int vl_fftn;
extern COSIN_TABLE *vl_fft_table;
extern unsigned int *vl_fft_permute;
extern float *vl_buffer;
extern float *vl_agc;
extern int vl_first_pos;
extern int vl_last_pos;
extern int vl_traces_mode;
extern int vl_signal_type;
extern int vl_false_guesses;
extern int vl_true_guesses;
extern int vl_missed_guesses;
extern int vl_begin;
extern int vl_end;

extern VOICELAB_PARM vl;

extern short int *vl_trace;
#define MAX_VL_TRACES 5
extern float vlt_y0[MAX_VL_TRACES];
extern int vlt_pointer;
extern float vlt_ampfac;
extern int vlt_step;
extern int vlt_shift;
extern float vl_minval;


void speech_proc_lab(void);
void open_tx_input(void);
void close_tx_input(void);
void open_tx_output(void);
void close_tx_output(void);
void init_txmem(void);

